<template>
  <basic-container>
<!--    <avue-crud :option="option"-->
<!--               :table-loading="loading"-->
<!--               :data="data"-->
<!--               :page.sync="page"-->
<!--               :permission="permissionList"-->
<!--               :before-open="beforeOpen"-->
<!--               v-model="form"-->
<!--               ref="crud"-->
<!--               @row-update="rowUpdate"-->
<!--               @row-save="rowSave"-->
<!--               @row-del="rowDel"-->
<!--               @search-change="searchChange"-->
<!--               @search-reset="searchReset"-->
<!--               @selection-change="selectionChange"-->
<!--               @current-change="currentChange"-->
<!--               @size-change="sizeChange"-->
<!--               @refresh-change="refreshChange"-->
<!--               @on-load="onLoad">-->
<!--      <template slot="menuLeft">-->
<!--&lt;!&ndash;        <el-button type="danger"&ndash;&gt;-->
<!--&lt;!&ndash;                   size="small"&ndash;&gt;-->
<!--&lt;!&ndash;                   icon="el-icon-delete"&ndash;&gt;-->
<!--&lt;!&ndash;                   plain&ndash;&gt;-->
<!--&lt;!&ndash;                   v-if="permission.billsitem_delete"&ndash;&gt;-->
<!--&lt;!&ndash;                   @click="handleDelete">删 除&ndash;&gt;-->
<!--&lt;!&ndash;        </el-button>&ndash;&gt;-->
<!--      </template>-->
<!--    </avue-crud>-->
    <avue-crud ref="crud" :option="option" :data="data" @row-update="addUpdate" @row-click="handleRowClick" @on-load="onLoad">
<!--      <template slot="age" slot-scope="{row}">-->
<!--        <el-tag>{{row.age}}</el-tag>-->
<!--      </template>-->
<!--      <template slot="ageForm" slot-scope="{row,disabled}">-->
<!--        自定义:<el-input v-model="row.age" :disabled="disabled"></el-input>-->
<!--      </template>-->
      <template slot="menuLeft">
        <el-button @click="addRow" size="small">添加10条</el-button>
      </template>
      <template slot="menu" slot-scope="{row,index,size,type}">
        <el-button @click="addBreakRow(index)" :size="size" :type="type">向上添加</el-button>
        <el-button @click="addNextRow(index)" :size="size" :type="type">向下添加</el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/estate/billsitem";
  import {mapGetters} from "vuex";

  export default {
    name:'bills-item',
    // props:{
    //   pidprop:{type:String}
    // },
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          border: true,
          index: true,
          editBtn:false,
          addBtn:false,
          addRowBtn:true,
          cellBtn:true,
          dialogClickModal: false,
          column: [
            {
              label: "缴费项名称",
              prop: "itemName",
              cell: true,
              rules: [{
                required: true,
                message: "请输入缴费项名称",
                trigger: "blur"
              }]
            },
            {
              label: "缴费金额",
              prop: "itemFee",
              cell: true,
              rules: [{
                required: true,
                message: "请输入缴费金额",
                trigger: "blur"
              }]
            },
            {
              label: "备注",
              prop: "itemDesc",
              cell: true,
              rules: [{
                required: true,
                message: "请输入备注",
                trigger: "blur"
              }]
            },
            {
              label: "账单id",
              prop: "pid",
              cell: true,
              rules: [{
                required: true,
                message: "请输入账单id",
                trigger: "blur"
              }]
            },
          ]
        },
        data: [

          {$cellEdit:true}
          ]
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.billsitem_add, false),
          viewBtn: this.vaildData(this.permission.billsitem_view, false),
          delBtn: this.vaildData(this.permission.billsitem_delete, false),
          editBtn: this.vaildData(this.permission.billsitem_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      addUpdate(form,index,done,loading){
        this.$message.success('模拟网络请求')
        setTimeout(() => {
          this.$message.success('关闭按钮等待')
          loading()
        }, 1000)
        setTimeout(() => {
          this.$message.success(
            '编辑数据' + JSON.stringify(form) + '数据序号' + index
          )
          done()
        }, 2000)
      },
      addRow() {
        add(row).
        // then(() => {
        //   this.onLoad(this.page);
        //   this.$message({
        //     type: "success",
        //     message: "操作成功!"
        //   });
        //   done();
        // }, error => {
        //   loading();
        //   window.console.log(error);
        // });
        this.$message.success('正在添加，请稍后')
        setTimeout(() => {
          for (let i = 0; i < 10; i++) {
            this.$refs.crud.rowCellAdd({
              name: '',
            });
          }
        }, 500)
      },
      addNextRow(index){
        this.data.splice(index+1,0,{
          $cellEdit:true
        })
      },
      addBreakRow(index){
        this.data.splice(index,0,{
          $cellEdit:true
        })
      },
      handleRowClick(row, event, column) {
        this.$message({
          showClose: true,
          message: '序号' + row.$index,
          type: 'success',
        });
      },



      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        console.log("缴费项");
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
